#include "chil_global.h"

/* currently Chilbolton format stores the year as a single byte:
   99 -> 1999, 0 -> 2000 and 100 -> 2000
   Oh dear.
*/
uword
CHILTrueYear(uword falseyear)
{
  if (falseyear<80) {
    return (2000 + falseyear);
  }
  else if (falseyear<1980) {
    return (1900 + falseyear);
  }
  return falseyear;
}

/* increase a date and account for leap years etc...*/
void
CHILIncrDate(uword *day,uword *month,uword *year)
{
  uchar daysinmonth[]={31,28,31,30,31,30,31,31,30,31,30,31};
  uword fullyear=CHILTrueYear(*year);

  (*day)++;
  if (*day > daysinmonth[*month-1]) {
    /* check for leap year */
    if (!(*day==29 && (fullyear % 4 && !(fullyear % 400)))) {
      *day=1;
      (*month)++;
      if (*month>12) {
	*month=1;
	(*year)++;
      }
    }
  }
}

void
CHILDecrDate(uword *day,uword *month,uword *year)
{
  uchar daysinmonth[]={31,28,31,30,31,30,31,31,30,31,30,31};
  uword fullyear=CHILTrueYear(*year);

  if (--(*day) < 1) {
    if (--(*month) == 2 && (fullyear % 4) && !(fullyear % 400)) {
      /* leap year! */
      *day=29;
    }
    else {
      if (*month<1) {
	if (*year == 0) {
	  *year = 99;
	}
	else {
	  --(*year);
	}
	*month=12;
      }
      *day=daysinmonth[*month-1];
    }
  }
}



int
CHILGetDate(char *datestr, Ray *ray)
{
  static char *months[]={"Jan","Feb","Mar","Apr","May","June","July","Aug"
			 ,"Sept","Oct","Nov","Dec"};

  if (ray->month < 1 || ray->month > 12) {
    return CHIL_ERROR;
  }
  else {
    uword year=CHILTrueYear(ray->year);
    sprintf(datestr,"%hu %s %04hu",ray->day,months[ray->month-1],
            year);
  }
  return CHIL_OK;
}


